package com.sf.javase.day07.homework;

public class CreditCard extends DepositCard{
    private Double maxDraft;//本月可透支总额度
    private Double overDraft;// 本月已透支的额度


    @Override
    public void withdraw(double money) {
        if(money > (getBalance()+maxDraft-overDraft)){
            System.out.println("超出透支额度");
            return;
        }
        if (money <= getBalance()){  //不需要透支
            super.withdraw(money);
            return;
        }
        if(money > getBalance() &&money <= (getBalance()+maxDraft-overDraft)){
            overDraft += money - getBalance();
            setBalance(0.0);
            return;
        }
    }

    @Override
    public void save(double money) {
        if(money < 0){
            System.out.println("存款金额不能为负数");
            return;
        }else if(money <= overDraft){
            overDraft -= money;
        } else {
            setBalance(money-overDraft);
            overDraft = 0.0;
        }
    }

    public CreditCard() {
    }

    public CreditCard(Double maxDraft, Double overDraft) {
        this.maxDraft = maxDraft;
        this.overDraft = overDraft;
    }

    public Double getMaxDraft() {
        return maxDraft;
    }

    public void setMaxDraft(Double maxDraft) {
        this.maxDraft = maxDraft;
    }

    public Double getOverDraft() {
        return overDraft;
    }

    public void setOverDraft(Double overDraft) {
        this.overDraft = overDraft;
    }

    @Override
    public String toString() {
        return "CreditCard{" +
                "maxDraft=" + maxDraft +
                ", overDraft=" + overDraft +
                "余额"+getBalance()+
                '}';
    }
}
